#ifndef SCALDAMCC_H
#define SCALDAMCC_H

#include "iotools.h"
#include "alias.h"
struct matrix;
struct vector;


class scaldamcc
/**
  This class defines scalar damage with crack closure material model.
  The different type of norms for the computing parameters of
  the damage function can be used.
*/
/**
*/
{
 public:
  scaldamcc (void);
  ~scaldamcc (void);
  void read (XFILE *in);
  void elmatstiff (matrix &d,long ipp);
  void damfuncpar(long ipp, vector &eps, vector &kappa);
  double damfunction(long ipp, vector &kappa, vector &eps);
  void matstiff (matrix &d,long ipp,long ido);
  void nlstresses (long ipp,long im,long ido);
  void updateval (long ipp,long im,long ido);
  double epsefunction ();
  
  
  ///
  double k0;
  ///
  double at;
  /// tensile strength
  double bt;
  ///
  double ac;
  /// strength at compression
  double bc;
  ///
  double beta;
  ///
  double k;
  /// function type for evaluation damage funtion parameter
  paramf_type ft;
};

#endif
